// Unlimited Mining -- Dirt lottery
// Lotto bricks give random rewards
// The magnitude of the reward is based on depth


if (isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
	{
   if (!$RTB::RTBR_ServerControl_Hook)
     exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

	 RTB_registerPref("Lotto Blocks","Unlimited Mining","$Dig_Data_LottoBlocksEnabled","bool","GameMode_UnlimitedMining",true,0,0,"ToggleLottoBlocks");
	}
else
	{
	 $Dig_Data_LottoblocksEnabled=true;
	}

if ( !isObject($Dig_LottoBlock) )
  {
	 $Dig_LottoBlock = new ScriptObject(MineLotto)
       {
        name="Lotto Block";
        value=0;
        color=4;
        minPercent=0;
        maxPercent=0.1;
        depth=0;
        colorfx=3;
        radioactive=false;
       };
	 OreData.add($Dig_LottoBlock);
  }


// return true of this block should be placed
function mineLotto::CheckPlace(%this, %pos, %random)
   {
		if ( %this.disabled==1)
			return false;
		//echo("check place lotto");
		return MineOre::CheckPlace(%this, %pos, %random);
   }

// place the block
function MineLotto::placeAt(%this, %pos, %random)
   {
 	  %z = mabs(getword(%pos, 2));
	  if ( %z < 1)
		  %z=1;

		// amount of hp for lotto blocks.  -- very high so players dont accidently mine them
	  %health = mfloor(getRandom(50,150)*%z*0.7);
    return PlaceBrick(%pos, %health, %this.color, %this.colorFx, %this.ShapeFx, %this);
   }
//function RadioactiveLotto::placeAt(%this, %pos, %random)
//   {
//    %brick = MineLotto::placeAt(%this, %pos, %random);
//
//    %brick.multiplier=getRandom(5,20);
//    %brick.health*=%brick.multiplier;
//    %brick.radioactive=true;
//    echo("spawn radioactive lotto: " @ %pos);
//    return %brick;
//   }

function MineLotto::getMineName(%this)
   {
		return "<color:11FFAA>" @ %this.name;
   }
//function RadioactiveLotto::getMineName(%this)
//   {
//    return "<color:FFFF00>" @ %this.name;
//   }

// Mine a lotto brick
function MineLotto::mined(%this, %client, %brick, %mode)
   {
		%health=$modeHealth[%mode];
		if ( %health > 0)
		  {
       if (%client.pickaxeNum)
         %brick.health -= 1*%client.pickaxeNum;
       else
         %brick.health--;
			 }
		%brick.health*= %health;

		// if the brick is dead - give rewards
		if (( %mode !$= "bomb") && (%mode !$="drill") )
	  	if ( %brick.health < 1)
	  	  {
	  		 Dig_MineLottoBlock(%brick, %client);
         if ( isObject(%client))
           %client.AddOreLog(%this, 0 , true);
	  	  }
   }


// player has mined a lottery block - give an "interesting" reward
function Dig_MineLottoBlock(%brick, %client)
	{
   %reward = getrandom(1,09);
	 switch ( %reward)
	   {
	 	  case 1:
				 Dig_DeathReward(%client, %brick);
	 	  case 2:
         Dig_CashReward(%client, %brick, 0.5);
	 	  case 3:
         Dig_HeatsuitReward(%client, %brick, 0.5);
	 	  case 4:
         Dig_RadSuitReward(%client, %brick, 0.5);
      case 5:
         Dig_DirtReward(%client, %brick, 0.5);
      case 6:
         Dig_bombReward(%client, %brick);
      case 7:
         Dig_NoReward(%client, %brick);
      case 8:
				 Dig_Pickreward(%client, %brick);
      case 9:
         Dig_GlobalReward(%client, %brick, 1);
	   }
  }

// Lotto "buff".  make brick values double or zero for some time
function Dig_GlobalReward(%client, %brick, %level)
   {
    %amount = %level + 1;
    if ( %client.Dig_LottoBuff)
      {
       $ModeMoney["normal"] *= %amount;
       if ( $ModeMoney["normal"] == 0)
         {
          $ModeMoney["normal"] = %amount;
         }
       $ModeMoney["bomb"]   = 0;
       messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>All ores are worth " @ $ModeMoney["normal"] @ "x $$ for " @ %amount @ " min");
       messageAll('', "<color:FFFFFF>"@ %client.getPlayerName() @" <color:00FF00>Found a lotto block buff - all ores are worth " @ $ModeMoney["normal"] @ "x for "  @ %amount @ " mins");
       if ( %level > 1)
         AddLog(%client, "R Lotto", "Buff | x" @ $ModeMoney["normal"] @" for " @ %amount);
       else
         AddLog(%client, "Lotto", "Buff | x" @ $ModeMoney["normal"] @" for " @ %amount);
       $Dig_bombSave = $Dig_Data_BombSizeBuyLimit;
       $Dig_Data_BombSizeBuyLimit = 0;
      }
    else
      {
       $ModeMoney["normal"]=0;
       $ModeMoney["power"]=0;
       $ModeMoney["bomb"]=0;
       $ModeMoney["drill"]=0;
       messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>All ores are worth NOTHING for " @ %amount @ " min");
       messageAll('', "<color:FFFFFF>"@ %client.getPlayerName() @" <color:00FF00>Found a lotto block buff - all ores are worth NOTHING for " @ %amount @ " mins");
       AddLog(%client, "Lotto", "Buff | x0 for " @ %amount);
      }

    %client.Dig_LottoBuff++;
    if ( %client.Dig_LottoBuff > 1)
      %client.Dig_LottoBuff=0;
    if ( $Dig_Buff > 0)
      {
       cancel($Dig_Buff);
      }
    $Dig_Buff = schedule(1000*60 * %amount, 0 , "Dig_RestoreMoney");

    for (%c = 0; %c < ClientGroup.getCount(); %c++)
      {
       %client = ClientGroup.getObject(%c);
       if (%client.hasSpawnedonce )
         {
          %client.sendMiningStatus();
         }
      }
    echo("$Dig_bombSave " @ $Dig_bombSave);
    echo("$Dig_Data_BombSizeBuyLimit set to" @ $Dig_Data_BombSizeBuyLimit);
   }

// restore the lotto "buff" back to its origional state
function Dig_RestoreMoney()
   {
    $ModeMoney["normal"]=1;
    $ModeMoney["power"]=0;
    $ModeMoney["bomb"]=0.25;
    $ModeMoney["drill"]=0;
    messageAll('', "<color:00FF00>All ores are now worth their original amount");

    for (%c = 0; %c < ClientGroup.getCount(); %c++)
      {
       %client = ClientGroup.getObject(%c);
       if (%client.hasSpawnedonce )
         {
          %client.sendMiningStatus();
         }
      }
    if ( $Dig_BombSave > 0)
      {
       $Dig_Data_BombSizeBuyLimit = $Dig_bombSave;
       echo("$Dig_bombSave " @ $Dig_bombSave);
       echo("$Dig_Data_BombSizeBuyLimit set to" @ $Dig_Data_BombSizeBuyLimit);
       if ( $Dig_Data_BombSizeBuyLimit == 0)
         {
          $Dig_Data_BombSizeBuyLimit=15;
          error("bomb size limit reset to 15");
         }
      }
   }

function Dig_Noreward(%client, %brick)
   {
		messageClient(%client, '', "<color:00FF00>The lotto block gives you a message on your screen");
   }

// lotto block blows up
function Dig_BombReward(%client, %brick)
   {
		// Give / explode a bomb based on depth

    %pos = %brick.getPosition();
    %z= getWord(%pos, 2);

    if ( %z > 0)
      {
       %size = $Dig_Data_BombSizeMax * ( %z / $Dig_Data_Maxheight);
      }
    if ( %z < 0)
      {
       %size = $Dig_Data_BombSizeMax * ( %z / $Dig_Data_MaxDepth);
      }
   %size=mfloor(mabs(%size));
   AddLog(%client, "Lotto", "bomb | " , %size, 1);
	 if ( %client.Dig_Lottobomb)
		 {
		  %client.bomb=%size;
		  messageClient(%client, '', "<color:00FF00>the lotto block gave you a level " @ %size @ " bomb");
     }
	 else
		 {
			%brick.health=1;
			dig_DoBombAnyway(%brick, %brick.getPosition(), %client, %size+1);
			messageAll('', "<color:FFFFFF>"@ %client.getPlayerName() @" <color:00FF00>Was killed by a lotto Bomb");
			%client.player.kill();
		 }
	 %client.Dig_LottoBomb++;
	 if ( %client.Dig_LottoBomb > 1)
		 %client.Dig_LottoBomb=0;
   }

// lotto block kills player
function Dig_DeathReward(%client, %brick)
   {
	 if ( %client.Dig_LottoDeath)
		 {
			messageClient(%client, '', "<color:00FF00>The Hostile Lotto block fails to kill you");
      AddLog(%client, "Lotto", "kill | failed");
		 }
	 else
		 {
			if ( getRandom(1,2) == 2)
			  {
         %client.instantRespawn();
				 messageClient(%client, '', "<color:00FF00>The Hostile Lotto block Punts you back to start");
				 return;
			  }
			%client.player.schedule(100, "kill");
		  messageAll('', "<color:FFFFFF>"@ %client.getPlayerName() @" <color:00FF00>Was killed by a hostile lotto block");
      AddLog(%client, "Lotto", "kill | bomb " @ %size);
		 }

	 %client.Dig_LottoDeath++;
	 if ( %client.Dig_LottoDeath> 1)
		 %client.Dig_LottoDeath=0;

    %p = new Projectile()
     {
      dataBlock = Dig_BombProjectile;
      initialPosition = %brick.getposition();
      initialVelocity = "0 0 0";
      sourceObject = 0;
      client = %obj.client;
      sourceSlot = 0;
     };
   MissionCleanup.add(%p);

   %p.explode();
   }

// Award +/- a pick level
function Dig_Pickreward(%client, %brick)
	{
	 %pos = %brick.getPosition();

	 if ( %client.Dig_LottoPick==0)
			%amount = 1;
	 else
			%amount = -1;

	 %client.Dig_LottoPick++;
	 if ( %client.Dig_LottoPick > 1)
		 %client.Dig_LottoPick=0;

   AddLog(%client, "Lotto " ,"pick | "@ %amount, 1);
	 if ( %amount > 0)
	   {
			messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You got " @ %amount @ " pick levels");
	   }
	 else
		 {
	 		messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You LOST " @ mabs(%amount) @ " pick levels");
		 }
   %client.addPick(%amount);
	 if ( %client.pickAxeNum < 1)
	   {
			%client.pickAxeNum=1;
			%client.pickLevel=1;
	   }
  }

// Award +/- cash based on depth
function Dig_CashReward(%client, %brick, %level)
	{
	 %pos = %brick.getPosition();
   %reward= mabs(getWord(%pos, 2) ) * 8;
	 	if ( %reward < 1)
	 		 %reward=1;

	 if ( %client.Dig_LottoCash ==0)
      %amount = 0-%reward;
	 else
      %amount = %reward;
   %amount*=%level;
	 %client.Dig_LottoCash++;
	 if ( %client.Dig_LottoCash > 1)
		 %client.Dig_LottoCash =0;

	 if ( %amount > 0)
	   {
			messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You got $" @ %amount);
	   }
	 else
		 {
	 		messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You LOST $" @ mabs(%amount));
		 }
   if ( %level > 1)
      %client.AddMoney( %amount, "R Lotto ", "cash | " @ %amount, 1);
   else
      %client.AddMoney( %amount, "Lotto ", "cash |" @ %amount, 1);
  }

// Award +/- heatsuits based on depth
function Dig_HeatsuitReward(%client, %brick, %level)
	{
	 %pos = %brick.getPosition();
   %reward= mFloor(mabs(getWord(%pos, 2) ) * 0.25);
	 	if ( %reward < 1)
	 		 %reward=1;

	 if ( %client.Dig_LottoHeat==0)
			%amount = %reward;
	 else
			%amount = 0-%reward;

   %amount=mfloor(%amount*%level);
	 %client.Dig_LottoHeat++;
	 if ( %client.Dig_Lottoheat > 1)
		 %client.Dig_LottoHeat=0;
   if ( %level > 1)
     AddLog(%client, "R Lotto " , "heatsuit | "@ %amount);
   else
     AddLog(%client, "Lotto " , "heatsuit |" @ %amount);

	 if ( %amount > 0)
	   {
			messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You got " @ %amount @ " Heatsuit layers");
	   }
	 else
		 {
	 		messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You LOST " @ mAbs(%amount) @ " heatsuit layers");
		 }
	 %client.heatsuit+=%amount;
	}

// Award +/- radsuits based on depth
function Dig_radsuitReward(%client, %brick, %level)
  {
   %pos = %brick.getPosition();
   %reward= mFloor(mabs(getWord(%pos, 2) ) * 0.15);
    if ( %reward < 1)
       %reward=1;

   if ( %client.Dig_Lottorad==0)
      %amount = %reward;
   else
      %amount = 0-%reward;
   %amount=mfloor(%amount*%level);
   %client.Dig_Lottorad++;
   if ( %client.Dig_Lottorad > 1)
     %client.Dig_Lottorad=0;

   if ( %level > 1)
     AddLog(%client, "R Lotto " , "radsuit | " @ %amount);
   else
     AddLog(%client, "Lotto " , "radsuit | " @ %amount);

   if ( %amount > 0)
     {
      messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You got " @ %amount @ " radsuit layers");
     }
   else
     {
      messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You LOST " @ mAbs(%amount) @ " radsuit layers");
     }
   %client.radsuit+=%amount;
  }

// Award +/- dirt based on depth
function Dig_DirtReward(%client, %brick, %level)
	{
	 %pos = %brick.getPosition();
	 %reward= mFloor(mabs(getWord(%pos, 2) ) );
	 	if ( %reward < 1)
	 		 %reward=1;

	 if ( %client.Dig_LottoDirt==0)
			%amount = %reward;
	 else
			%amount = 0-%reward;
   %amount*=%level;
	 %client.Dig_LottoDirt++;
	 if ( %client.Dig_LottoDirt > 1)
		 %client.Dig_LottoDirt=0;
   if ( %level > 1)
     AddLog(%client, "R Lotto " , "Dirt |" @ %amount );
   else
     AddLog(%client, "Lotto " , "Dirt |" @ %amount );

	 if ( %amount > 0)
	   {
			messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You got " @ %amount @ " Dirt");
	   }
	 else
		 {
	 		messageClient(%client, '', "<color:0000FF>Lotto Brick:<color:00FF00>You LOST " @ mAbs(%amount) @ " Dirt");
		 }
   %client.AddDirt(%amount);
	}

// Allows players to reset everything back to zero
function serverCmdResetMyStats(%client)
	{
	 if ( %client.pickaxenum < 0)
	   {
			messageClient(%client, '',"<color:FFFFFF>Your ability to reset stats has been revoked");
			echo(%client.getPlayername() @ " reset stats revoked");
			return;
	   }

	 commandToClient(%client,'MessageBoxYesNo', "Reset stats?", "Are you sure?", 'resetConfirm');
  }

// confirm stats reset
function serverCmdResetConfirm(%client)
   {
   if ( %client.pickaxenum < 0)
     {
      messageClient(%client, '',"<color:FFFFFF>Your ability to reset stats has been revoked");
      echo(%client.getPlayername() @ " reset stats revoked");
      return;
     }

    messageClient(%client, '',"<color:FFFFFF>Reset confirmed");
    AddLog(%client, "reset","stats", 1);
	  %client.pickaxenum=1;
    if ( %client.mineMoney < 0)
      {
       %client.PickLevel = mFloor(%client.pickLevel / 2);
      }
    if ( %client.minemoney < -1000)
      {
       %client.pickLevel=0;
      }
	  %client.minemoney=0;
	  %client.heatsuit=0;
	  %client.bomb=0;
	  %client.sendMiningStatus();
	  messageClient(%client, '',"<color:FFFFFF>Your stats have been reset to 0");
   }

