$Dig_PickaxeColor = "0.000000 0.000000 0.900000 1.000000";
$Dig_CementAxeColor = "0.500000 0.500000 0.500000 1.000000";

if (isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
  {
   if (!$RTB::RTBR_ServerControl_Hook)
     exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

   RTB_registerPref("Brick Limit","Unlimited Mining","$Dig_Data_BrickLimit","int 0 350000","GameMode_UnlimitedMining",250000,0,0);
   RTB_registerPref("Heatsuit Cost","Unlimited Mining","$Dig_Data_HeatsuitCost","int 0 5000","GameMode_UnlimitedMining",200,0,0);
   RTB_registerPref("Radiation suit Cost","Unlimited Mining","$Dig_Data_RadsuitCost","int 0 5000","GameMode_UnlimitedMining",500,0,0);
   RTB_registerPref("Light Cost","Unlimited Mining","$Dig_Data_LightCost","int 0 5000","GameMode_UnlimitedMining",25,0,0);
   RTB_registerPref("Dirt Cost","Unlimited Mining","$Dig_Data_DirtCost","int 0 5000","GameMode_UnlimitedMining",1,0,0);
  }
else
  {
   $Dig_Data_BrickLimit = 250000;   // reset server after this # of bricks
   $Dig_Data_lightCost=25;
   $Dig_Data_HeatSuitCost=200;
   $Dig_Data_DirtCost=1;
   $Dig_Data_radsuitCost=250;
  }
$Dig_Data_MaxDepth=-25000;
$Dig_Data_MaxHeight=6000;


exec("./miningDatablocks.cs");
exec("./Donating.cs");
exec("./Ores.cs");
exec("./playerOres.cs");
exec("./Bombs.cs");
exec("./DirtLottery.cs");
exec("./Drill.cs");
exec("./Admin.cs");
exec("./Structures.cs");
exec("./Acheivements.cs");
exec("./MiningAdminGui.cs");
exec("./help.cs");

function servercmdstartDig(%client)
   {
    if (%client.bl_id != getNumKeyID() && findLocalClient() !$= %client)
      {
       messageClient(%client, '', "You are not the host so you cannot start dig mode");
       return;
      }
    // check for required color set

    // is it downloaded?
    if ( !isFile("Add-ons/Colorset_Trueno/colorSet.txt") )
      {
       messageClient(%client, '', "<color:FF0000>You do not have the right color set installed.  Please read instructions.txt included with the mod");
       messageClient(%client, '', "<color:FF0000>You can also goto the forums to download the required colorset");
       return;
      }
    // is it activated?
    if ( getColorIDTable(54) !$= "0.803922 0.666667 0.486275 1.000000" || getColorIDTable(45) !$= "0.976471 0.976471 0.976471 1.000000" )
      {
       messageClient(%client, '', "<color:FF0000>You do not have Trueno's colorset<color:FFFFFF>Activated");
       messageClient(%client, '', "<color:FFFFFF>Activate the color set via RTB, or search the forums for instructions how to activate a colorset");
       return;
      }

    // check to make sure 4x4 cube exists
    if ( !isObject(brick4xCubeData) )
      {
       messageClient(%client, '', "<color:FF0000>You do not have the 4x4 cube brick loaded");
       messageClient(%client, '', "<color:FFFFFF>This is part of a default addon and should come standard with your copy of blockland.");
       messageClient(%client, '', "<color:FFFFFF>Activate the <color:FF0000>\"Brick_Large_Cubes\"<color:FF0000> addon to continue");
       return;
      }

    if ( !isFile("Add-ons/Tool_RPG/Lil_Pickaxe.dts") )
      {
       messageClient(%client, '', "<color:FF0000>You do not have the RPG_Tool addon installed");
       messageClient(%client, '', "<color:FFFFFF>Please download this addon and try again");
       return;
      }

    Dig_StartAnyway(%client);
    $Dig_NumCycles=0;  //server started manually - reset # of cycles
   }

// start dg mode regardless of who the client is
function Dig_StartAnyway(%client)
   {
    if ( $Dig_On)
      {
       error("Dig already running - cant start a 2nd time");
       return;
      }
    $Dig_allowedMission["Slate"] = 1;
    $Dig_allowedMission["Slate Aurora"] = 1;
    $Dig_allowedMission["Destruct"] = 1;
    $Dig_groundID["Slate"] = 5;
    $Dig_groundID["Slate Aurora"] = 6;
    $Dig_groundID["Destruct"] = 5;

    if (!$Dig_allowedMission[missionInfo.name])
      {
       messageClient(%client, '', "Dig mode is only usable in Slate, Slate Aurora, and Destruct");
       return;
      }

    $Dig_host = %client;
    $Dig_host_brickgroup = %client.brickgroup;
    $Dig_host_id = %client.bl_id;

    %ground = missionGroup.getobject($Dig_groundID[missionInfo.name]);
    if (missionInfo.name $= "Slate Aurora")
      %water = missionGroup.getobject(7);

    if (isObject(%ground))
      %ground.delete();

    if (isObject(%water))
      %water.delete();

    %spawnsphere = playerDropPoints.getobject(0);
    %spawnsphere.radius = 5;
    %spawnsphere.RayHeight = 3;

    deleteVariables("$Dig_placedDirt*");
    messageAll('', "<color:00FF00>Dig mode is now enabled");

    //for (%x = -5.5; %x <= 5.5; %x++)
    //   for (%y = -5.5; %y <= 5.5; %y++)
    //      {
    //       Dig_PlaceCement(%x*2 SPC %y*2 SPC 0, "brick4xCubeData");
    //       Dig_PlaceCement(%x*2 SPC %y*2 SPC 10, "brick4xCubeData");
    //      }
    //
    //%pos[0] = "10 10";
    //%pos[1] = "10 -10";
    //%pos[2] = "-10 10";
    //%pos[3] = "-10 -10";
    //
    //for (%a = 0; %a < 4; %a++)
    //  {
    //   Dig_PlaceCement(%pos[%a] SPC 3, "brick8xCubeData");
    //   Dig_PlaceCement(%pos[%a] SPC 7, "brick8xCubeData");
    //  }
    //%light = Dig_PlaceCement("0 0 8.75", "brick2x2FRoundData");
    //%light.setLight(PlayerLight);

    CheckDirt();

    activatepackage(Dig_package);
    activatepackage(UnLag);

    exec("config/server/MiningStats.cs");
   if ( isFile("config/server/MiningData.cs") )
     {
      OreData.delete();
     }

    exec("config/server/MiningData.cs");
    activatepackage(DedicatedAutoMinigame);

    //for (%z = 0; %z <= 3; %z++)
    //  {
    //   for (%x = 0; %x < 8; %x++)
    //      Dig_PlaceDirt(-7 + %x*2 SPC 11 SPC 2+%z*2);
    //
    //   for (%y = 0; %y < 8; %y++)
    //      Dig_PlaceDirt(11 SPC 7 - %y*2 SPC 2+%z*2);
    //
    //   for (%x = 0; %x < 8; %x++)
    //      Dig_PlaceDirt(7 - %x*2 SPC -11 SPC 2+%z*2);
    //
    //   for (%y = 0; %y < 8; %y++)
    //      Dig_PlaceDirt(-11 SPC -7 + %Y*2 SPC 2+%z*2);
    //  }
    GenSpawnLocation("0 0 0");
    GenSpawnLocation("250 0 0");
    GenSpawnLocation("0 250 0");

     if ($Server::Dedicated)
      {
        SetupDedicatedMinigame();
       $DediMini.reset();
      }
    else
      // respawn the active players
      for (%c = 0; %c < ClientGroup.getCount(); %c++)
         if (ClientGroup.getObject(%c).hasSpawnedOnce)
            ClientGroup.getObject(%c).instantRespawn();

    $Dig_on = 1;

    // load mining stats for all clients
    for (%c = 0; %c < ClientGroup.getCount(); %c++)
      {
       %client = ClientGroup.getObject(%c);
       %client.LoadMiningStats();
       %client.SetupAcheivements();
       Dig_CheckLogin(%client);
      }

    // Start monitoring timer
    Dig_Monitor();
    Dig_ExpireOres();
    if ( $Server::dedicated)
      {
       schedule(5000, 0, "Dig_ResetMinigame");
      }
    $Pref::Server::WelcomeMessage="Welcome to Unlimited mining %1.  \c3Type /help for info.";

    setRayTracerCenter("0 0 0");

    // start job processor
    StartJobProcessor();
   }

function servercmdStopDig(%client)
   {
    if (%client.bl_id != getNumKeyID() && findLocalClient() !$= %client)
      {
       messageClient(%client, '', "You are not the host so you cannot stop dig mode");
       return;
      }

     Dig_Stopanyway(%client);
    cancel($Dig_MonitorTimer);

    if (isObject($DediMini))
      $DediMini.delete();
    deactivatepackage(Dig_package);
   }

// stopdig regardless of who %client is
function Dig_stopanyway()
   {
    messageAll('', "<color:00FF00>Dig mode is off");
    $Dig_on = 0;

    if ( $Dig_NumCycles > 4)
      {
       messageAll('', "<color:FFFFFF>-- **<color:FF0000>Server Reboot<color:FFFFFF>**--");
       messageAll('', "<color:FFFFFF>-- **<color:FF0000>Server Reboot<color:FFFFFF>**--");
       messageAll('', "<color:FFFFFF>-- **<color:FF0000>Server Reboot<color:FFFFFF>**--");
       messageAll('', "<color:FFFFFF>-- **<color:FF0000>Server Reboot<color:FFFFFF>**--");
       messageAll('', "<color:FFFFFF>-- **<color:FF0000>Server Reboot<color:FFFFFF>**--");
       messageAll('', "<color:FFFFFF>-- **<color:FF0000>Server Reboot<color:FFFFFF>**--");
       messageAll('', "<color:FFFFFF>-- ** Server will return in 1-2 min ** --");
       schedule(3000, 0, "quit");

       // turn on autostart flag
       $Dig_Stats_SavedAutoexec=true;
       export("$Dig_stats_Saved*", "config/server/miningStats.cs");
       return;
      }

    $Dig_host_brickgroup.chainDeleteAll();
    MainBrickGroup.chainDeleteAll();

    Dig_saveStats();

    if ( isObject($LavaQueue) )
       {
        $LavaQueue.delete();
       }
    ResetDrills();

    $Pref::Server::WelcomeMessage="";
    $Dig_on = 0;
    echo("Delete Dig_PlacedDirt1*"); deleteVariables("$Dig_placedDirt1*");
    echo("Delete Dig_PlacedDirt2*"); deleteVariables("$Dig_placedDirt2*");
    echo("Delete Dig_PlacedDirt3*"); deleteVariables("$Dig_placedDirt3*");
    echo("Delete Dig_PlacedDirt4*"); deleteVariables("$Dig_placedDirt4*");
    echo("Delete Dig_PlacedDirt5*"); deleteVariables("$Dig_placedDirt5*");
    echo("Delete Dig_PlacedDirt6*"); deleteVariables("$Dig_placedDirt6*");
    echo("Delete Dig_PlacedDirt7*"); deleteVariables("$Dig_placedDirt7*");
    echo("Delete Dig_PlacedDirt8*"); deleteVariables("$Dig_placedDirt8*");
    echo("Delete Dig_PlacedDirt9*"); deleteVariables("$Dig_placedDirt9*");
    echo("Delete Dig_PlacedDirt*");  deleteVariables("$Dig_placedDirt*");

    Dig_changeMapTry();

    deactivatepackage(Dig_MiningAdminButton);
    deactivatePackage(DedicatedAutoMinigame);

    if (isObject($DediMini))
      $DediMini.delete();
   }

function Dig_changeMapTry()
   {
    echo("Dig_changeMapTry " @ $Server::BrickCount @ " bricks left");
    if ($server::BrickCount < 1)
      {
       changeMap(missionInfo.name);

       // clear all players bottomBrint stuff
       for (%c = 0; %c < ClientGroup.getCount(); %c++)
         {
          %client = ClientGroup.getObject(%c);
          commandtoClient(%client, 'bottomPrint', "", 1);
         }

        // check to see if auto-reset is in progress
       if ( $Dig_cycle == true)
         {
           if ( !isObject($Dig_Host) )
             {
              // no host client -- make one
              echo("no host object - faking it");

              %client = new ScriptObject() {
                isAdmin=1;
                brickgroup = $Dig_host_brickgroup;
                bl_id = GetNumKeyID();
              };
              if ( !isObject(%client.brickgroup) )
                {
                 %bl_id = getNumKeyID();
                 %brickgroup=new SimGroup("BrickGroup_" @ %bl_id)
                 {
                  client=0;
                  bl_id = %bl_id;
                  name="\c1BL_ID: " @ %bl_id @ "\c1\c0";
                 };
                 %client.brickgroup = %brickgroup;
                $Dig_host_brickgroup = %brickgroup;
              }
             }
           else
             %client = $Dig_host;

          Dig_RestoreMoney();
          // restart dig mode in 15 seconds
          schedule(1000*15,0, "dig_startanyway", %client);
          $Dig_Cycle = false;
         }
        FlushLog();
       return;
      }
    messageAll('', "<color:FFFFFF>"@$Server::Brickcount @ " Bricks left");

    schedule(2000, 0, Dig_changeMapTry);
   }

function servercmdPowerMode(%client)
   {
    if (!%client.isAdmin)
      return;

    if (%client.dig_powermode)
      {
       messageClient(%client, '', "Power mode is now off");
       %client.dig_powermode = 0;
      }
    else
      {
       messageClient(%client, '', "Power mode is now on");
       %client.dig_powermode = 1;
      }
   }

// place a 'dirt' brick.  can be regular dirt, or an ore brick depending on random percent
function Dig_PlaceDirt(%pos)
   {
    %x = getWord(%pos, 0);
    %y = getWord(%pos, 1);
    %z = getWord(%pos, 2);

    %type = 0;
    %dirt=OreData.getObject(0);
    %random = getRandom() * 100;
    if ( %random < 85 )
        return %dirt.placeAt(%pos, %random);

    %random = getRandom() * 100;
    if ( $Dig_Lava.checkPlace(%pos, %random) )
      {
       return $Dig_Lava.placeAt(%pos);
      }

    %c = OreData.getCount();
    for ( %x=1; %x < %c; %x++)
      {
       %ore = OreData.getObject(%x);
       if ( %ore.checkPlace(%pos, %random) )
         {
          return %ore.placeAt(%pos);
          break;
         }
      }
    return %dirt.placeAt(%pos, getRandom() * 100);
   }

// replace dirt at all around %position
function Dig_rebuildDirt(%position)
   {
    %x = getWord(%position, 0);
    %y = getWord(%position, 1);
    %z = getWord(%position, 2);
    %position[0] = %x+2 SPC %y SPC %z;
    %position[1] = %x-2 SPC %y SPC %z;
    %position[2] = %x SPC %y+2 SPC %z;
    %position[3] = %x SPC %y-2 SPC %z;
    %position[4] = %x SPC %y SPC %z+2;
    %position[5] = %x SPC %y SPC %z-2;

    for (%a = 0; %a < 6; %a++)
     {
      %x = getWord(%position[%a], 0);
      %y = getWord(%position[%a], 1);
      %z = getWord(%position[%a], 2);
      %dirt = $Dig_placedDirt[%position[%a]];
      if ( strlen(%dirt) == 0 )
        {
         Dig_PlaceDirt(%position[%a]);
        }
      else
        {
         if ( mFloor(%dirt) == 0 )
           {
            MineOre::PlaceContinue(0,%dirt, %position[%a] );
           }
        }
     }
   }


// mode normal: %sound=0; lava=1; money=1; health=1; discover=1;
// powermode:   %sound=0; lava=0; money=0; health=0; discover=0;
// bomb:        %sound=1; lava=0; money=1; health=0; discover=0;

$ModeSound["normal"]=0;
$ModeSound["power"]=0;
$ModeSound["bomb"]=1;
$ModeSound["drill"]=1;
$Modelava["normal"]=1;
$Modelava["power"]=0;
$Modelava["bomb"]=0;
$ModeLava["drill"]=0;
$ModeMoney["normal"]=1;
$ModeMoney["power"]=0;
$ModeMoney["bomb"]=0.25;
$ModeMoney["drill"]=0;
$ModeHealth["Normal"]=1;
$ModeHealth["power"]=0;
$ModeHealth["bomb"]=0;
$ModeHealth["drill"]=0;
$ModeDiscover["Normal"]=1;
$ModeDiscover["power"]=0;
$ModeDiscover["bomb"]=0;
$ModeDiscover["drill"]=0;

function Dig_mineBrick(%brick, %pos1, %client, %mode)
   {
    if (%brick.isMineable)
      {
       %pos = %brick.getPosition();
       %z=getword(%pos,2);
       if ( %z > $Dig_Data_Maxheight || %z < $Dig_Data_MaxDepth)
         {
          %brick.isMineable=false;
          return;
         }
       if ( !isObject(%client) )
          return;

       if (%mode $="")
         {
          %mode="normal";
         }
       if ( %client.dig_powermode == 1)
          {
           %mode = "power";
          }

       %sound = $ModeSound[%mode];
       %lava  = $ModeLava[%mode];

       if ( %sound==0 )
         {
          serverPlay3D(hammerHitSound, %pos1);
         }
       %brick.type.mined(%client, %brick, %mode);
       if ( %brick.health < 1)
         {
          if ( %lava == 1)
            {
             commandToClient(%client, 'centerPrint', "Mined "@ %brick.type.getMineName(%brick), 5);
             %client.sendMiningStatus();
            }
          Dig_rebuildDirt(%pos);
          $Dig_placedDirt[%pos] = -2;   // flag as deleted
          %brick.delete();
          if ( %mode $= "normal")
            {
             %client.checkDepth();
            }
         }
       else
         commandToClient(%client, 'centerPrint', "Health: <color:FFFFFF>"@ %brick.health SPC %brick.type.getMineName(%brick), 3);
       return;
      }
    if ( %brick.isCement)
      {
       messageClient(%client, '', "<color:FFFF00>You cant mine cement, use your gun");
      }
   }

// display an error message for %client
function Dig_DisplayError(%client, %msg)
   {
    commandToClient(%client, 'centerPrint', "<color:FF0000>" @ %msg, 5);
   }

// upgrade pick by 1 level
function serverCmdUpgradePick(%client)
   {
    %cost = Dig_PickCost(%client);
    if (%cost > %client.mineMoney)
      {
       Dig_DisplayError(%client, "You do not have enough money. You need: $"@ mAbs(%client.mineMoney - %cost ) @ " more");
       return;
      }
    %client.addPick(1);

    %client.AddMoney( -%cost, "upgradepick " @ %client.pickaxenum);
    messageClient(%client, '', "Pick upgraded to level "@ %client.pickaxeNum @"($"@ %cost @")");

    %client.MineArmor=%client.pickaxeNum;
    %client.sendMiningStatus();
   }

// upgrade pick w/o any chat spam
function serverCmdUpgradePickS(%client)
   {
    %cost = Dig_PickCost(%client);
    if (%cost > %client.mineMoney)
      {
       Dig_DisplayError(%client, "You do not have enough money. You need: $"@ mAbs(%client.mineMoney - %cost ) @ " more");
       return;
      }
    %client.addPick(1);
    %client.AddMoney( -%cost, "upgradepick " @ %client.pickaxenum);
    %client.sendMiningStatus();
    %client.MineArmor=%client.pickaxeNum;
   }

// at the cost of 10% of your money - upgrade everything in 1 shot
function serverCmdUpgradeAll(%client, %count)
   {
    if ( %count < 1)
      {
       %fee = mfloor(%client.MineMoney * 0.1);
       %cost = Dig_PickCost(%client);
       if ( (%cost + %fee) > %client.mineMoney)
         {
          Dig_DisplayError(%client, "You cant afford to upgrade all at once. try: <color:FF0000>/upgradepick instead");
          return;
         }
       %client.AddMoney( -%fee, "upgradeall");
      }
    else
      AddLog(%client, "upgradeall", %count, 1);

    %start = %client.pickaxeNum;
    %tmp = %count;
    %cost = Dig_PickCost(%client);
    while ( %client.MineMoney > %cost || %client.pickaxenum > 65536 )
      {
       %client.addpick(1);
       %client.mineMoney-=%cost;
       messageClient(%client, '', "Pick upgraded to level "@ %client.pickaxeNum @"($"@ %cost @")");
       %client.MineArmor=%client.pickaxeNum;
       %client.sendMiningStatus();
       if ( %count)
         {
          %tmp--;
          if ( %tmp < 1)
            {
             // generates a log entry reflecting the final money
             %client.AddMoney(1, "upgradeall", 0);
             AddLog(%client, "upgradeall", "from " @ %start @ " to " @ %client.pickaxenum);
             %client.MineArmor=%client.pickaxeNum;
             return;
            }
         }
       %cost = Dig_PickCost(%client);
      }

    // generates a log entry reflecting the final money
    %client.AddMoney(1, "upgradeall", 0);
    AddLog(%client, "upgradeall", "from " @ %start @ " to " @ %client.pickaxenum);
    %client.MineArmor=%client.pickaxeNum;
   }

// upgradeall w/o the chat spam
function serverCmdUpgradeAllS(%client, %count)
   {
    if ( %count < 1)
      {
       %fee = mfloor(%client.MineMoney * 0.1);
       %cost = Dig_PickCost(%client);
       if ( (%cost + %fee) > %client.mineMoney)
         {
          Dig_DisplayError(%client, "You cant afford to upgrade all at once. try: <color:FF0000>/upgradepick instead");
          return;
         }
       %client.AddMoney( -%fee, "upgradeall");
      }
    else
      AddLog(%client, "upgradeall", %count, 1);

    %start = %client.pickaxeNum;
    %tmp = %count;
    %cost = Dig_PickCost(%client);
    while ( %client.MineMoney > %cost || %client.pickaxenum > 65536 )
      {
       %client.addpick(1);
       %client.mineMoney-=%cost;
       %client.MineArmor=%client.pickaxeNum;
       %client.sendMiningStatus();
       if ( %count)
         {
          %tmp--;
          if ( %tmp < 1)
            {
             return;
            }
         }
       %cost = Dig_PickCost(%client);
      }

    // generates a log entry reflecting the final money
    %client.AddMoney(1, "upgradeall", 0);
    AddLog(%client, "upgradeall", "from " @ %start @ " to " @ %client.pickaxenum);
    %client.MineArmor=%client.pickaxeNum;
   }

// buy an inventory item that goes in the tools slot
function buyThing(%client, %thing, %price)
   {
    if ( %client.mineMoney >= %price)
      {
       %slot = -1;
       %item = %thing.getID();
       for ( %x=0; %x <= 4; %x++ )
         {
          if ( %client.player.tool[%x]==0)
            {
             %slot = %x;
            }
          if ( %client.player.tool[%x] == %item )
            {
             Dig_DisplayError(%client, "you already have a " @ %thing.uiName);
             return;
            }
         }
       if ( %slot == -1)
         {
          Dig_DisplayError(%client, "You dont have room in your inventory for a " @ %thing.uiName);
          return;
         }

       %client.AddMoney( -%price, "buy " @ %thing.uiName);
       %client.player.tool[%slot] = %item;
       MessageClient(%client, 'MsgItemPickup', '', %slot, %item );
       commandToClient(%client, 'centerPrint', "<color:00FF00>You bought a " @ %thing.uiName @ " for \c3$" @ %price, 3);
      }
    else
      {
       Dig_DisplayError(%client, "You cannot afford a " @ %thing.uiName @ " for \c3$" @ %price);
      }
   }

// buy something
function serverCmdBuy(%client, %thing, %level)
   {
    %amount = mfloor(mabs(%level));

    if ( %thing $= "gun")
      {
       buyThing(%client, GunItem, 250);
       return;
      }
   if ( %thing $= "placer")
     {
      buything(%client, DiggingCementItem, 100);
      return;
     }
   if ( %thing $= "invplacer")
     {
      buything(%client, BlockadeItem, 100);
      return;
     }
   if ( %thing $= "light")
     {
      serverCmdBuyLight(%client);
      return;
     }
   if ( %thing $= "pick")
     {
      serverCmdUpgradePick(%client);
      return;
     }
   if ( %thing $= "heatsuit")
     {
      serverCmdBuyHeatsuit(%client, %amount);
      return;
     }
   if ( %thing $= "bomb")
     {
      buybomb(%client, %amount);
      return;
     }
	 if ( %thing $= "dirt")
	   {
			buydirt(%client, %amount);
			return;
	   }
   if ( %thing $= "radsuit")
     {
      serverCmdBuyRadSuit(%client, %amount);
     }

   serverCmdHelp(%client);
  }

// buy some dirt
function buyDirt(%client, %amount)
  {
	 %price = mabs(%amount * $Dig_Data_DirtCost);
	 if ( %client.mineMoney < %price)
	   {
      Dig_DisplayError(%client, "You need $" @ %price @ " to buy " @ %amount @ " dirt");
	    return;
		 }

	 commandToClient(%client, 'centerPrint', "You bought " @ %amount @ " dirt for $" @ %price, 3);
	 %client.AddMoney( -%price, "buy dirt " @ %amount);
   %client.addDirt(%amount);
	 %client.sendMiningStatus();
  }

// Buy a light
function serverCmdBuyLight(%client)
  {
   if (%client.mineLight)
	 	 {
	 	  Dig_DisplayError(%client, "You already bought a light!");
	 	  return;
	 	 }
	 if ( %client.mineMoney < $Dig_Data_LighCost)
	   {
			Dig_DisplayError(%client, "You cannot afford a light for \c3$" @ $Dig_Data_LightCost);
			return;
	   }

   %client.mineLight = 1;
   commandToClient(%client, 'centerPrint', "You have bought a light for \c3$" @ $Dig_Data_LightCost, 3);
	 %client.AddMoney( -$Dig_Data_LightCost, "buy light");
   serverCmdLight(%client);
   %client.sendMiningStatus();
  }

// buy some heatsuits
function serverCmdBuyHeatSuit(%client, %layerValue)
  {
	 %layers = mFloor(%layerValue);
   if ( %layers < 1)
     {
      %layers = 1;
     }
	 %price = $Dig_Data_HeatsuitCost * %layers;
   if ( %client.mineMoney >= %price )
     {
      %client.heatSuit += %layers;
			%client.AddMoney( -%price, "buyheatsuit " @ %layers);
      if ( %layers ==1)
        {
         commandToClient(%client, 'centerPrint', "You have bought a heat suit for \c3$" @ %price, 3);
        }
      else
        {
         if ( %client.heatsuit > %layers)
           commandToClient(%client, 'centerPrint', "You added " @ %layers @ " layers to your heat suit for \c3$" @ %price, 3);
         else
           commandToClient(%client, 'centerPrint', "You have bought a " @ %layers @ " layer heat suit for \c3$" @ %price, 3);
        }
			%client.sendMiningStatus();
     }
   else
    {
		 Dig_DisplayError(%client, "You cannot afford a heat suit \c3$" @ %price );
    }
  }

// buy some radsuits
function serverCmdBuyradSuit(%client, %layerValue)
  {
   %layers = mFloor(%layerValue);
   if ( %layers < 1)
     {
      %layers = 1;
     }
   %price = $Dig_Data_radsuitCost * %layers;
   if ( %client.mineMoney >= %price )
     {
      %client.radSuit += %layers;
      %client.AddMoney( -%price, "buyradsuit " @ %layers);
      if ( %layers ==1)
        {
         commandToClient(%client, 'centerPrint', "You have bought a rad suit for \c3$" @ %price, 3);
        }
      else
        {
         if ( %client.radsuit > %layers)
           commandToClient(%client, 'centerPrint', "<color:0000FF>You added " @ %layers @ " capacity to your rad suit for \c3$" @ %price, 3);
         else
           commandToClient(%client, 'centerPrint', "<color:0000FF>You have bought a " @ %layers @ " capacity rad suit for \c3$" @ %price, 3);
        }
      %client.sendMiningStatus();
     }
   else
    {
     Dig_DisplayError(%client, "You cannot afford a rad suit \c3$" @ %price );
    }
  }

// Penalize %client for cheating
function FineForCheating(%client, %amount)
	{
	 Dig_DisplayError(%client, "You have been fined $" @ %amount @" for trying to cheat");
	 %client.AddMoney( -%amount, "Fine cheating");
	 %client.sendMiningStatus();
  }

function DiggingPickaxeImage::onFire(%this, %obj, %slot)
  {
   parent::onFire(%this, %obj, %slot);
   %obj.playThread(2, "armAttack");
  }

function DiggingPickaxeImage::onStopFire(%this, %obj, %slot)
  {
   %obj.playThread(2, "root");
  }

// "hack" into the print gun's onFire code to use the cement placer
function DiggingCementImage::onFire(%this, %arga, %argb)
  {
   PrintGunImage::onFire(%this, %arga, %argb);
  }

function BlockadeImage::onFire(%this, %arga, %argb)
  {
   PrintGunImage::onFire(%this, %arga, %argb);
  }

// return the cost for %client to upgrade pick to the next level
function Dig_PickCost(%client)
  {
   if ( %clitn.picklevel > 65535)
     {
      return -1;
     }
   %num = %client.pickLevel + 1;
   if ( %num < 10)
     {
      return 50;
     }
   return mFloor( mPow(%num,1.3) ) + 50;
  }

// monitor brick count and save stats every so often
function Dig_Monitor()
   {
		Dig_SaveStats();
		if ( !Dig_monitorBrickCount() )
		  {
			 return;
		  }

	 // save stats every 5min
	 $Dig_MonitorTimer = schedule(1000*60*5, MissionGroup, Dig_Monitor);
   }

//save all stats to a file: config/server/miningStats.cs
function Dig_saveStats()
  {
   for (%c = 0; %c < ClientGroup.getCount(); %c++)
    {
     %client = ClientGroup.getObject(%c);
     %client.saveMiningStats();

    }
   export("$Dig_stats_Saved*", "config/server/miningStats.cs");
	 FlushLog();
  }

// check brick count every so often and reset things if needed
function Dig_MonitorBrickCount()
  {
   messageAll('', "Brick count <color:FFFFFF>" @ $Server::BrickCount @ " of " @ $Dig_Data_BrickLimit);
	 AddLog(0, "Brick Count" , $Server::BrickCount @ " of " @ $Dig_Data_BrickLimit, 1);
   AddLog(0, "Job Size", $JobQueue.entries.getCount() @ " jobs", 1);
   if ( $Dig_Data_BrickLimit > 0)
     if ( $Server::BrickCount > $Dig_Data_BrickLimit )
       {
        messageAll('', "<color:FFFFFF>-- **<color:FF0000>WARNING<color:FFFFFF>**--");
        messageAll('', "<color:FFFFFF>-- Brick count is above limit, server will be reset soon");
        messageAll('', "<color:FFFFFF>-- **<color:FF0000>WARNING<color:FFFFFF>**--");
        messageAll('', "<color:FFFFFF>-- **<color:FF0000>WARNING<color:FFFFFF>**--");
        messageAll('', "<color:FFFFFF>-- Brick count is above limit, server will be reset soon");
        messageAll('', "<color:FFFFFF>-- **<color:FF0000>WARNING<color:FFFFFF>**--");

        for (%c = 0; %c < ClientGroup.getCount(); %c++)
          {
           %client = ClientGroup.getObject(%c);
           commandToClient(%client,'MessageBoxOK', "SERVER RESET IN 30 SECONDS", "-- Server reset in 30 seconds --\n SERVER RESET\n\nServer RESET IN 30 SECONDS");
          }

        schedule(1000*30,0,"Dig_CycleServer");
        return false;
       }

	 return true;
  }

// Start the reset process
function Dig_CycleServer()
  {
   BlobUseReport();
   messageAll('', "<color:FF0000>server Reset NOW");
	 AddLog(0, "Cycle Server", "Cycle_Server");
   $Dig_cycle=true;
 	 $Dig_NumCycles++;
   Dig_Stopanyway();
  }

// send updated mining stats to the client
function GameConnection::sendMiningStatus(%this)
  {
   if(!%this.pickaxeNum)
      %this.pickaxeNum = 0;

   if(!%this.mineMoney)
      %this.mineMoney = 0;

   if(!%this.heatsuit)
      %this.heatsuit= 0;

   if(!%this.dig_0)
      %this.dig_0 = 0;

   %msg = "<font:arial bold:14>\c6Cash \c3$"@ %this.mineMoney;
   %msg = %msg @ "   \c6Dirt \c3"@ %this.dig_0;
   %msg = %msg @ "   \c6Pick level \c3"@ %this.pickaxeNum;
   %msg = %msg @ "   \c6Next pick \c3$"@ Dig_pickCost(%this);
   %msg = %msg @ "   \c6LOC \c3";

   if ( isObject(%this.player) )
     {
      %pos = %this.player.getPosition();
      %msg = %msg @ mfloor(getword(%pos, 0)) SPC mFloor(getWord(%pos, 1)) SPC mFloor(getWord(%pos, 2));
     }
   %msg = %msg @ "   \c6HS: \c3" @ %this.heatsuit;
   %msg = %msg @ "   \c6RS: \c3" @ %this.radsuit;
   if ( %this.player.radDamage > 0)
     {
      %msg = %msg @ " <color:0000FF>Rad: " @ %this.player.radDamage;
     }
   if ( %this.mineArmor < %this.pickAxenum)
     {
      %msg1 = %msg1 @ "Armor: " @ %this.MineArmor @ " of " @ %this.pickaxeNum;
     }
   if ( $ModeMoney["normal"] != 1)
     {
      %msg1 = %msg1 @ "   <color:00FF00>Lotto buff: x" @ $ModeMoney["normal"];
     }
   commandtoClient(%this, 'bottomPrint', %msg @ "<br>" @ %msg1, -1);
   %this.score=%this.pickaxenum;

   if ( %this.bomb > 0)
     {
      commandToClient(%this, 'CenterPrint', "<color:FFFFFF>Bomb Mode - size:" @ %this.bomb @ "\nhit any brick", -1);
     }
  }

// send a message box to the client displaying rules for them to read
function GameConnection::sendRules(%this)
  {
   if ($Dig_placedRead[%this.bl_id]==1)
     {
      %this.ruleNumber=0;
      commandToClient(%this,'MessageBoxOK', "Unlimited Infinite Mining Mod", "Use the pickaxe to mine bricks\n\n /upgradepick to level your pick\n\n /upgradeall for multiple upgrades (costs extra)\n\n /help for more");
     }
   else
     {
      %this.ruleNumber=getRandom(1,1000);
      commandToClient(%this,'MessageBoxOK', "Unlimited Infinite Mining Mod", "Use the pickaxe to mine bricks\n\n /upgradepick to level your pick\n\n /upgradeall for multiple upgrades (costs extra)\n\n /help for more\n say: /Ihavereadtherules " @ %this.rulenumber @ " for free stuff");
     }
  }

// give rewards for actually reading the rules
function serverCmdIHaveReadTheRules(%client, %code)
  {
   if ( %client.ruleNumber==0)
     {
      return;
     }
   if ( %code == %client.ruleNumber)
     {
      messageClient(%client, '', "<color:0000FF>RTFM Bonus<color:00FF00>You got 10 pick levels");
      messageClient(%client, '', "<color:0000FF>RTFM Bonus<color:00FF00>You got $1,000");
      messageClient(%client, '', "<color:0000FF>RTFM Bonus<color:00FF00>This only works once");
      %client.addMoney(1000, "RTFM", 1);
      %client.addPick(10);
      %client.ruleNumber=0;
      $Dig_placedRead[%client.bl_id]=1; // works once per server reset
     }
   else
     Dig_Displayerror(%client, "Wrong secret code");
  }

// save mining stats for client to a global variable
function GameConnection::saveMiningStats(%this)
  {
   if (!%this.hasSpawnedonce)
     {
      echo("player has not spawned - aborting save stats");
      return;
     }

   %id = %this.bl_id;
   $Dig_stats_Saved[%id] = %this.pickaxeNum SPC %this.PickLevel SPC %this.MineMoney SPC %this.heatsuit SPC %this.radsuit SPC getDateTime();
   AddLog(%this, "save stats", "bl_id " @ %id @ " pick " @ %this.pickAxeNum @ " lvl " @ %this.pickLevel @ " $" @ %this.mineMoney @ " HS " @ %this.heatsuit @ " RS " @ %this.radsuit, 1 );
   %this.WriteOreLogs();
  }

// load mining stats from global variable into the client
function GameConnection::loadMiningStats(%this)
  {
   %id = %this.bl_id;
   if ( !$Dig_stats_Saved[%id] )
		 {
      %this.pickaxeNum = 1;
			%this.pickLevel = 1;
      %this.mineMoney = 0;
			%this.heatsuit = 0;
			%this.radsuit = 0;
      return 0;
		 }
   %this.pickaxeNum = getWord($Dig_stats_Saved[%id], 0);
	 %this.pickLevel  = getWord($Dig_stats_Saved[%id], 1);
   %this.mineMoney  = getWord($Dig_stats_Saved[%id], 2);
   %this.heatsuit   = getWord($Dig_Stats_Saved[%id], 3);
	 %this.radsuit    = getWord($Dig_Stats_Saved[%id], 4);
   if ( %this.pickAxeNum > 65536)
     {
      %this.pickAxeNum = 65536;  // Cap for high pick levels
     }
   %this.mineArmor = %this.pickaxenum;

   AddLog(%this, "Load stats", "bl_id " @ %id @ " pick " @ %this.pickAxeNum @ " lvl " @ %this.pickLevel @ " $" @ %this.mineMoney @ " HS " @ %this.heatsuit @ " RS " @ %this.radsuit, 1 );
   %this.sendMiningStatus();
   return 1;
  }


function DiggingPickaxeProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
  {
   if ( !$Dig_On)
     {
      return;
     }

   %client = %obj.client;
   if ( %client.bomb > 0)
     {
      if ( %client.bomb > $Dig_Data_BombSizeMax)
        {
         AddLog(%client, "Abort bomb", "level " @ %client.bomb @ " bomb aborted", 1);
         %client.bomb=0;
         return;
        }
      Dig_DoBomb(%col, %pos, %client, %client.bomb);
      return;
     }
   if ( %client.MineDrill > 0)
     {
      Dig_StartDrill(%col, %pos, %client, %normal);
      return;
     }
   Dig_mineBrick(%col, %pos, %client);
  }

package UnLag
	{
   function GameConnection::ResetVehicles(%this)
     {
		  // package resetVehicles to do nothing because it seems to scan all bricks.
			// when the brick count is > 80k or so, the lag gets unbearable
     }
  };

package Dig_package
{
    // Spawn the player and give them whats needed
    function GameConnection::spawnPlayer(%this)
      {
       %parent = Parent::spawnPlayer(%this);
       if ( !$Dig_on)
         {
          echo("Dig off - no loading of stats " @ %this.getPlayerName() );
          return %parent;
         }
       %this.canFire=false;
       if ( isObject(%this.minigame ))
			   {
					%this.dig_enableCement();
			    %this.MineArmor=%this.pickaxenum;
			    %this.score = %this.pickaxenum;
			    %this.radDamage=0;
					return;
			   }
       // clear out player tools
       %this.player.cleartools();

       // Give player a pick
       %this.player.tool[0] = DiggingPickaxeItem.getID();
       MessageClient(%this, 'MsgItemPickup', '', 0, DiggingPickaxeItem.getID() );

       // Admins also get a wrench
       if ( %this.isAdmin)
         {
          %this.player.tool[1] = WrenchItem.getID();
          MessageClient(%this, 'MsgItemPickup', '', 1, WrenchItem.getID() );
         }

       // let player place cement
       %this.dig_enableCement();

			 %this.MineArmor=%this.pickaxenum;
			 %this.score = %this.pickaxenum;
			 %this.radDamage=0;
      }

    // hook into autoAdminCheck to load player stats
    function GameConnection::autoAdminCheck(%this)
      {
       %parent = parent::autoAdminCheck(%this);
       if ( !$Dig_on)
         {
          echo("Dig off - no loading of stats " @ %this.getPlayerName() );
          return %parent;
         }
       if (!%this.loadMiningStats())
         {
          %this.pickaxeNum = 1;
          %this.mineMoney = 0;
					%this.heatsuit = 0;
         }

       Dig_CheckLogin(%this);
       %this.setupAcheivements();
       return %parent;
      }

    // save player stats when client leaves game
    function GameConnection::onClientLeaveGame(%this)
      {
       %parent = parent::onClientLeaveGame(%this);
       if ( %this.bl_id == getNumKeyID() )
         {
          // setup temp objects for "fake" host
          $Dig_host_brickgroup = %this.brickgroup;
          $Dig_Host = new ScriptObject() {
              isAdmin=1;
              brickgroup = $Dig_host_brickgroup;
              bl_id = GetNumKeyID();
            };
         }

       if ( !$Dig_On)
         {
          echo("Dig off - no saving of stats " @ %this.getPlayerName() );
          return %parent;
         }
       %this.saveMiningStats();
       AddLog(%this, "Leave Game");
       return %parent;
      }

    // turn on light if player has purchased one
    function serverCmdLight(%client)
      {
       if (%client.mineLight || !$Dig_on)
          parent::serverCmdLight(%client);
        else
					Dig_DisplayError(%client, "You have not bought a light yet. You can by a light for \c3" @ $Dig_Data_LightCost);
      }

    // send rules to client after they connect the first time
    function GameConnection::OnClientEnterGame(%this)
      {
       %this.schedule(2500, sendRules);
       if (%this.bl_id == getNumKeyID() )
         {
          // host has joined/re-joined - update the globals
          $Dig_host = %this;
          $Dig_host_brickgroup = %this.brickgroup;
          $Dig_host_id = %this.bl_id;
          echo("updated host info");
         }

       return Parent::OnClientEnterGame(%this);
      }

    // Cement bricks can only be damaged by guns.
    function gunProjectile::onCollision(%this, %obj, %brick, %fade, %pos, %normal)
      {
       %this.directDamage =%obj.client.pickaxeNum;
			 if ( %brick.getClassName() $= "Player")
			   {
          // Target must be outside a spawn area
          if ( !%brick.client.canFire)
            {
             %this.directdamage=0;
             messageClient(%obj.client, '', "<color:FFFF00>target too close to spawn");
			      }
			    else
						{  // shooter must be outside spawn area
						 if ( isObject(%obj.client.player) )
               if ( !%obj.client.canFire)
  						   {
  						 		%this.directdamage=0;
                  messageClient(%obj.client, '', "<color:FFFF00>you are too close to spawn");
  						   }
						}

					%brick.client.mineArmor -= %this.directDamage;
					if ( %brick.client.mineArmor > 0)
						 %this.directDamage=0;
					else
						%brick.mineArmor=0;
				 }
       %parent = parent::onCollision(%this, %obj, %brick, %fade, %pos, %normal);
       if ( %brick.isCement == 1)
          Dig_DamageCement(%brick, %this, %obj);

       if ( %this.directDamage > 0)
          %obj.client.sendMiningStatus();

       return %parent;
      }

    function akimboGunProjectile::onCollision(%this, %obj, %brick, %fade, %pos, %normal)
      {
       %parent = parent::onCollision(%this, %obj, %brick, %fade, %pos, %normal);
       if ( %brick.isCement == 1)
         {
          Dig_DamageCement(%brick, %this, %obj);
         }
       return %parent;
      }

		function MinigameSO::displayScoresList(%this)
			{
			 // do nothing
			 echo("display scores bypassed");
      }

    function GameConnection::onDeath(%this,%sourceObject,%sourceClient,%damageType,%damageArea)
      {
       if ( %this !=%sourceClient)
         AddLog(%sourceClient, "killed", %this.getPlayerName() @ " | " @ %sourceClient.pickaxeNum SPC %this.pickaxeNum, 1 );

       return Parent::onDeath(%this,%sourceObject,%sourceClient,%damageType,%damageArea);
      }

    // Log chat messages, and attempt to prevent people from talking in all caps
    function serverCmdMessageSent(%client, %msg)
      {
       Parent::serverCmdMessageSent(%client, %msg);
       AddLog(%client, "chat", %msg);
       %newMsg = strupr(stripChars(%msg, "0123456789"));

       if ( strlen(%newMsg) > 5)
         {
          if ( !strcmp(%msg, %newMsg) )
            {
             %client.capsWarning++;
             if ( %client.capsWarning > 2)
               {
                messageClient(%client, '', "<color:FF0000>Please do not talk in ALL CAPS <color:FFFFFF>warning " @ %client.CapsMessage @ " of 5");
                %client.capsMessage++;
                if ( %client.capsMessage > 5)
                  {
                   %name = %client.getPlayerName();
                   KickName(%name);
                   messageAll('', "<color:FFFFFF>" @ %name @ "<color:00FF00> was kicked for excessive caps");
                  }
               }
            }
          else
            {
             if ( %client.capsWarning > 0)
               {
                if ( %client.capsMessage > 0)
                  {
                   %client.capsMessage-=0.1;
                  }
                else
                  {
                   %client.capsWarning-=0.1;
                  }
                if ( %client.capsMessage < 0)
                  %client.capsMessage=0;
                if ( %client.capsWarning < 0)
                  %client.capsWarning=0;
               }
            }
         }
       //if ( stripChars(%msg, "[]\=-()<>/., ") $= stripChars(%client.lastChat[%client.messageCount], "[]\=-()<>/., ") )
       //  {
       //   messageClient(%client, '', "Dont repeat yourself");
       //  }
       //
       //%client.messageCount++;
       //%client.lastChat[%client.messagCount] = %msg;
       //
       //if ( %client.messageCount > 3)
       //  {
       //   %client.messageCount=0;
       //  }
      }

    // return spawn point based on players pick level
    function GameConnection::GetSpawnPoint(%this)
      {
       if ( %this.pickaxeNum < 500)
         {
          %pos = VectorAdd(PlayerDropPoints.getObject(0).getPosition(), "0 0 2 ") @ " 0 0 1 0";
          return %pos;
         }

       if ( %this.pickaxeNum < 5000)
         {
          %pos = VectorAdd(PlayerDropPoints.getObject(1).getPosition(), "0 0 2 ") @ " 0 0 1 0";
          return %pos;
         }

       %pos = VectorAdd(PlayerDropPoints.getObject(2).getPosition(), "0 0 2 ") @ " 0 0 1 0";
       return %pos;
      }

    //  Disable clear bricks cmd, so players cant clear their cement blocks
    function serverCmdClearBricks(%client)
       {
        Dig_DisplayError(%client, "Clearbricks are disabled while mining");
       }
};

// give client some money
function GameConnection::addMoney(%this, %amount, %reason, %echo)
  {
   if ( %amount == 0)
     return;

   %this.mineMoney+= %amount;
   AddLog(%this, "money" , %this.mineMoney @ " | " @ %amount @ " | " @ %reason, %echo);
  }

// add an ore log entry
function GameConnection::AddOreLog(%this, %ore, %money, %radFlag)
  {
   if ( %money == 0)
      return;

   %this.mineMoney+= %money;
   if ( %radFlag)
     %key = "radioactive " @ %ore.name @ " | " @ %money;
   else
     %key = %ore.name @ " | " @ %money;

   if (%this.Ores[%key] > 0)
     %this.Ores[%key]++;
   else
     {
      %this.Ores[%key] = 1;
      %this.OreRecord = SetField( %this.OreRecord, getFieldCount(%this.OreRecord), %key);
     }
  }

// write the accumulated ore logs out as log entries
function GameConnection::WriteOreLogs(%this)
  {
   if ( getFieldCount(%this.OreRecord) == 0)
     return;

   for ( %a=1; %a < GetFieldCount(%this.OreRecord); %a++)
     {
      %log = getField(%this.OreRecord, %a);
      AddLog(%this, "mined", %log @ " | " @ %this.Ores[%log], 0);
      %this.Ores[%log]=0;
     }
   %this.OreRecord=0;
  }

// Add dirt to the client
function GameConnection::AddDirt(%this, %amount)
  {
   if ( %amount==0)
     {
      return;
     }
   %this.dig_0 += %amount;
   %this.checkDirt();
  }

function GameConnection::AddHeatsuit(%this, %amount)
   {
   }

function GameConnection::AddRadSuit(%this, %amount)
   {
   }

// add some pick levels to the client
function GameConnection::AddPick(%this, %amount)
   {
    if ( %this.pickaxenum <= 65536)
      {
       %this.pickaxeNum+= %amount;
       %this.pickLevel+= %amount;
      }
   }

// extract a number from %string - make sure its between 1 and %high
function getParamNumber(%string, %low, %high)
   {
		%v = mabs(mfloor(%string));
		if ( %v < %low)
		  {
			 %v=%low;
		  }
		if ( %v > %high)
		  {
			 %v=%high;
		  }
		return %v;
   }

// Add a log message
function addLog(%client, %operation, %data, %echo)
	{
	 if ( isObject(%client) )
	   {
			%string = getDateTime() @" | " @ %client.getPlayerName() @ " | " @ %operation @ " | " @ %data;
	   }
	 else
		 {
			%string = getDateTime() @ " | None | " @ %operation @ " | " @ %data;
     }
	 %entry = new ScriptObject() {
		line = %string;
	 };
	 if ( !isObject(GameLog) )
	   {
			new SimSet(GameLog) {};
	   }
	 GameLog.add( %entry);

	 if ( GameLog.getCount() > 100)
	   {
			FlushLog();
	   }
	 if ( %echo==1)
	   {
		  echo(%string);
	   }
  }

// write the contents of GameLog to a file
function FlushLog()
   {
		if ( isObject(GameLog))
		  {
			 echo("flush GameLog");
       %file=new FileObject();
       %file.openForAppend("config/server/MiningLog" @ stripChars(getWord(getDateTime(), 0),"/") @ ".txt");

	    	for ( %x=0; %x < GameLog.getCount(); %x++)
	    	  {
	    		 %file.writeLine( GameLog.getObject(%x).line );
	    	  }
	    	%file.close();
	    	%file.delete();
				GameLog.clear();
			}
		else
		  new SimSet(GameLog) {};
   }

// auto-start for dedicated servers
if ($Server::Dedicated)
	{
   deactivatepackage(DedicatedAutoMinigame);
	 exec("config/server/MiningStats.cs");
	 exec("config/server/MiningData.cs");
   if ( !isFile("config/server/MiningStats.cs") )
     {
      $Dig_Stats_SavedAutoexec = true;
     }

	 if ( $Dig_Stats_SavedAutoexec)
		 {
			echo("auto start scheduled in 5 sec");
      $Dig_cycle = true;
      schedule(5000, 0, "Dig_changeMapTry");
			$Dig_NumCycles=0;

			// turn off autostart flag
			$Dig_Stats_SavedAutoexec=false;
			export("$Dig_stats_Saved*", "config/server/miningStats.cs");
      activatepackage(DedicatedAutoMinigame);
     }
	}

function SetupDedicatedMinigame()
   {
    //setup minigame
    if ( isObject($DediMini) )
      {
        $DediMini.delete();
      }

    $DediMini = new ScriptObject() {
        brickDamage= 0;
        brickRespawnTime= 10000;
        class=miniGameSO;
        colorIdx= 2;
        EnableBuilding= 0;
        EnablePainting= 1;
        enableWand= 0;
        fallingDamage= 0;
        inviteOnly= 0;
        numMembers=1;

        playerDataBlock= PlayerStandardArmor;
        PlayersUseOwnBricks= 0;
        Points_BreakBrick= 0;
        Points_Die= 0;
        Points_KillPlayer= 1;
        Points_KillSelf= 0;
        Points_PlantBrick= 0;
        respawnTime= 2000;
        SelfDamage=1;

        StartEquip0=DiggingPickaxeItem.getID();
        StartEquip1=GunItem.getID();
        StartEquip2=0;
        StartEquip3=0;
        StartEquip4=0;

        title = "Mining Mayhem";
        useAllPlayersBricks= 0;
        useSpawnBricks= 0;
        VehicleDamage= 0;
        vehicleReSpawnTime= 0;
        weaponDamage= 1;
      };
    CheckDediMini();
   }

// clear the minigame from each player and reset things
function Dig_ResetMinigame()
   {
    for ( %a=0; %a < ClientGroup.getCount(); %a++)
      {
       %cl = ClientGroup.getobject(%a);
       if ( %cl.minigame != $dediMini)
         {
          $DediMini.addMember(%cl);
         }
      }
   }

function reducepicks()
   {
		for ( %a=0; %a < ClientGroup.getCount(); %a++)
		  {
			 %cl=ClientGroup.getObject(%a);
       if ( %cl.pickaxenum > 5000)
			   {
          echo("reducing5: " @ %cl.getPlayerName() );
          %cl.pickaxenum-=2;
          %cl.picklevel-=2;
			   }
       if ( %cl.pickaxenum > 2000)
         {
          echo("reducing2: " @ %cl.getPlayerName() );
          %cl.pickaxenum--;
          %cl.picklevel--;
         }
      }
   }
